<?php
/*
Plugin Name: Is Your Server Ready for WordPress 3.5 ?
Plugin URI: http://www.greenvilleweb.us/web-industry-news/wordpress-3-5-requirements/
Description: Is your site ready for WordPress 3.5? If your not sure your server meets the minimum requirements for 3.5 this plugin will let you know.
Version: 2
Author: Rew @ Greenville Web
Author URI: http://www.greenvilleweb.us/

*/
/*
  Copyright 2012 Geeenville Web
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/ 

add_action( 'admin_notices', 'RU_message' );

    
    function RU_message() 
    {

      global $wpdb;
      $t=mysql_query("select version() as ve");
      echo mysql_error();
      $r=mysql_fetch_object($t);
      define('MYSQL_VERSION', $r->ve); 
      $min_msql = '5.0.15';
      $min_php  = '5.2.0';
      $my_link ="http://wordpress.org/about/requirements/";

      if ( !extension_loaded( 'imagick' ) || !class_exists( 'Imagick' ) || !class_exists( 'ImagickPixel' ) ){
        $imagick = "<p class='UR_meh'>WordPress now has support for <b>Imagick</b> by default, unfortunately you don't have it on your server. <strong>But don't worry</strong> it's not a deal breaker. If your interested check out this post on " 
                    . "<a href='http://make.wordpress.org/core/2012/12/06/wp_image_editor-is-incoming/'>make.wordpress.org</a></p>";
      }else{
        $imagick = "<p><strong>Great!</strong>  You have Imagick installed. WordPress now has support for <b>Imagick</b> by default if your interested in what that is all about check out this post on " 
                    . "<a href='http://make.wordpress.org/core/2012/12/06/wp_image_editor-is-incoming/'>make.wordpress.org</a></p>";
      }
      
      if (function_exists('apache_get_modules')) {
        if (apache_get_modules('mod_rewrite')){
            $mod_rewrite =  '<p><strong>Great!</strong> The mod_rewrite Apache module installed</p>';
        } else {
            $mod_rewrite =  '<p class="UR_meh">The Apache module mod_rewrite <strong>may not be installed</strong>, please check with your host</p>';
        }
      }else{
        $mod_rewrite = '';
      }
      
      if ( version_compare(PHP_VERSION, $min_php) >= 0  && version_compare(MYSQL_VERSION, $min_msql) >= 0 ) {
        echo "<div id='RU_message' class='UR_good'><strong>Great!</strong> You are running PHP ".PHP_VERSION." with MySQL version: ".MYSQL_VERSION.". For more info, see <a href='$my_link'>$my_link</a>.$mod_rewrite $imagick</div>";
  	  
      }else{
  	    if ( version_compare(PHP_VERSION, $min_php) >= 0) {
  	      $php_message="Your version of PHP (v".PHP_VERSION.") meets the requirements";
  	    }else{
  	      $php_message="WordPress 3.5 will require PHP $min_php or greater. You are running PHP ".PHP_VERSION;
  	    }
  	    
    	  if ( version_compare(MYSQL_VERSION, $min_msql) >= 0 ) {
    	    $mysql_message="Your version of MySQL (v".MYSQL_VERSION.") meets the requirements";
    	  }else{
    	    $mysql_message="WordPress 3.5 will require MySQL $min_msql or greater. You are running MySQL ".MYSQL_VERSION;
    	  }
    	  
  	    echo "<div id='RU_message' class='UR_bad'>$php_message.<br/> $mysql_message. For more info, <a href='$my_link'>$my_link</a>. $mod_rewrite $imagick </div>";
  	  }
  	  
    }
    // We need some CSS to position the paragraph
    function RU_css() {
    	echo "
    	<style type='text/css'>
    	#RU_message {
        border-radius: 3px 3px 3px 3px;
        margin: 5px 15px 2px;
        padding: 0.6em;
      }
      .UR_bad{
        background-color:#FCEAEA;
        border: solid 2px OrangeRed;
       }
      .UR_good{
        background-color: #DDFFE8;
        border: #069B37 solid 2px;
      }
      .UR_meh{
        background-color: #FFFFCC;
        border: #BDB76B solid 1px;
        border-radius: 3px 3px 3px 3px;
        padding: 0.6em;
      }

    	</style>
    	";
    }

    add_action( 'admin_head', 'RU_css' );